package fr.lri.keller.td6;

import android.app.Fragment;
import android.app.FragmentManager;
import android.app.FragmentTransaction;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.TextView;

public class TD6Activity extends AppCompatActivity {

    private TD6ActivityFragment frag;
    private TD6ActivityFragment frag2;
    private FragmentManager fragmentManager;

    private TextView textViewNiveau;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_td6);

        // On récupère les objets de l'interface dont on a besoin
        textViewNiveau = (TextView) findViewById(R.id.textViewNiveau);

        // Initialisation du gestionnaire de fragments
        fragmentManager = getFragmentManager();

        // On initialise les fragments, soit en récupérant ceux qui existent déjà, soit en les
        // créant sinon
        frag = initFragment(R.id.frameLayoutFragment);
        frag2 = initFragment(R.id.frameLayoutFragment2);

        // On affiche le niveau
        textViewNiveau.setText("" + TD6ActivityFragment.niveau);
    }

    // Lorsque l'activité va être arrêtée pour une courte période, on attache les fragments qui
    // étaient détachés pour que leurs données soient sauvegardées
    @Override
    protected void onPause() {
        // On attache tous les fragments pour conserver les données
        attacher(frag, R.id.frameLayoutFragment);
        attacher(frag2, R.id.frameLayoutFragment2);
        // On appelle la méthode de la super-classe
        super.onPause();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_td6, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    // Cette méthode sert à créer un récupérer les fragments de l'activité, et les créer et les
    // attacher si ceux-ci n'existent pas
    private TD6ActivityFragment initFragment(int id) {
        // On récupère le fragment, ou null s'il n'existe pas encore
        TD6ActivityFragment fragment = (TD6ActivityFragment) fragmentManager.findFragmentById(id);

        // S'il n'existe pas, on le crée et on l'attache
        if (fragment == null) {
            fragment = new TD6ActivityFragment();
            FragmentTransaction transaction = fragmentManager.beginTransaction();
            transaction.add(id, fragment);
            transaction.commit();
        }

        return fragment;
    }

    // Cette méthode sert à attacher un fragment :
    // - s'il n'est pas attaché, on l'attache et on renvoie true
    // - sinon, on n'a rien à faire et on renvoie false
    private boolean attacher(Fragment f, int id) {
        if (f.isAdded()) {
            return false;
        } else {
            FragmentTransaction transaction = fragmentManager.beginTransaction();
            transaction.add(id, f);
            transaction.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_OPEN);
            transaction.commit();
            return true;
        }
    }

    // Cette méthode détache un fragment s'il est attaché, et l'attache sinon
    public void attacherDetacher(Fragment f, int id) {
        if (!attacher(f, id)) {
            // Si on n'a pas eu à l'attacher, c'est qu'il faut le détacher
            FragmentTransaction transaction = fragmentManager.beginTransaction();
            transaction.remove(f);
            transaction.setTransition(FragmentTransaction.TRANSIT_FRAGMENT_CLOSE);
            transaction.commit();
        }
    }

    public void clicAttacherDetacher(View view) {
        switch (view.getId()) {
            case R.id.buttonAD1:
                attacherDetacher(frag, R.id.frameLayoutFragment);
                break;
            case R.id.buttonAD2:
                attacherDetacher(frag2, R.id.frameLayoutFragment2);
                break;
        }

    }

    public void clickTheButton(View view) {
        switch (view.getId()) {
            case R.id.buttonClick1:
                frag.clickTheButton();
                break;
            case R.id.buttonClick2:
                frag2.clickTheButton();
                break;
        }
    }
}